<template>
  <!-- 授权用户 -->
  <el-dialog title="选择手机菜单" :visible.sync="visible" width="1000px" top="5vh" append-to-body>
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true">
      <el-form-item label="模块名称" prop="modelType">
        <el-select v-model="queryParams.modelType" placeholder="请选择模块名称" clearable>
          <el-option v-for="dict in dict.type.model_type" :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item label="菜单名称" prop="menuName">
        <el-input v-model="queryParams.menuName" placeholder="请输入菜单名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="菜单状态" prop="menuStatus">
        <el-select v-model="queryParams.menuStatus" placeholder="请选择菜单状态" clearable>
          <el-option v-for="dict in dict.type.sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row>
      <el-table @row-click="clickRow" ref="table" :data="userList" @selection-change="handleSelectionChange" height="260px">
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column label="模块名称" align="center" prop="modelType">
          <template slot-scope="scope">
            <dict-tag :options="dict.type.model_type" :value="scope.row.modelType"/>
          </template>
        </el-table-column>
        <el-table-column label="菜单名称" align="center" prop="menuName" />
        <el-table-column label="菜单路径" align="center" prop="menuUrl" />
        <el-table-column label="菜单图标" align="center" prop="menuIcon" />
        <el-table-column label="显示顺序" align="center" prop="menuNum" />
        <el-table-column label="菜单状态" align="center" prop="menuStatus">
          <template slot-scope="scope">
            <dict-tag :options="dict.type.sys_normal_disable" :value="scope.row.menuStatus"/>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total>0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList"/>
    </el-row>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="handleSelectApp">确 定</el-button>
      <el-button @click="visible = false">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { unallocatedAppList, authAppSelectAll } from "@/api/system/role"
export default {
  dicts: ['model_type', 'sys_normal_disable'],
  props: {
    // 角色编号
    roleId: {
      type: [Number, String]
    }
  },
  data() {
    return {
      // 遮罩层
      visible: false,
      // 选中数组值
      appIds: [],
      // 总条数
      total: 0,
      // 未授权用户数据
      userList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        roleId: null,
        modelType: null,
        menuName: null,
        menuStatus: null,
      }
    }
  },
  methods: {
    // 显示弹框
    show() {
      this.queryParams.roleId = this.roleId
      this.getList()
      this.visible = true
    },
    clickRow(row) {
      this.$refs.table.toggleRowSelection(row)
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.appIds = selection.map(item => item.id)
    },
    // 查询表数据
    getList() {
      unallocatedAppList(this.queryParams).then(res => {
        this.userList = res.rows
        this.total = res.total
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm")
      this.handleQuery()
    },
    /** 选择授权用户操作 */
    handleSelectApp() {
      const roleId = this.queryParams.roleId
      const appIds = this.appIds.join(",")
      if (appIds == "") {
        this.$modal.msgError("请选择要分配的用户")
        return
      }
      authAppSelectAll({ roleId: roleId, appIds: appIds }).then(res => {
        this.$modal.msgSuccess(res.msg)
        this.visible = false
        this.$emit("ok")
      })
    }
  }
}
</script>
